Crypto++ 8.9 Free C++ class library of cryptographic schemes

Public Types | Public Member Functions | List of all members
CFB_CipherTemplate< BASE > Class Template Referenceabstract

Base class for feedback based stream ciphers with SymmetricCipher interface. More...

Inheritance diagram for CFB_CipherTemplate< BASE >:

## Public Types
typedef BASE::PolicyInterface | PolicyInterface

## Public Member Functions
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Apply keystream to data. More...
void | Resynchronize (const byte *iv, int length=-1)
| Resynchronize the cipher. More...
unsigned int | OptimalBlockSize () const
| Provides number of ideal bytes to process. More...
unsigned int | GetOptimalNextBlockSize () const
| Provides number of ideal bytes to process. More...
unsigned int | OptimalDataAlignment () const
| Provides number of ideal data alignment. More...
bool | IsRandomAccess () const
| Flag indicating random access. More...
bool | IsSelfInverting () const
| Determines if the cipher is self inverting. More...
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...

## Detailed Description

### template<class BASE>
class CFB_CipherTemplate< BASE >

Base class for feedback based stream ciphers with SymmetricCipher interface.

Template Parameters

  BASE | AbstractPolicyHolder base class

Definition at line 567 of file strciphr.h.

## Member Function Documentation

## ◆ ProcessData()

template<class BASE >

void CFB_CipherTemplate< BASE >::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  |

Apply keystream to data.

Parameters

  outString | a buffer to write the transformed data
  inString | a buffer to read the data
  length | the size of the buffers, in bytes

This is the primary method to operate a stream cipher. For example:

        size_t size = 30;
        byte plain[size] = "Do or do not; there is no try";
        byte cipher[size];
        ...
        ChaCha20 chacha(key, keySize);
        chacha.ProcessData(cipher, plain, size);

You should use distinct buffers for inString and outString. If the buffers are the same, then the data will be copied to an internal buffer to avoid GCC alias violations. The internal copy will impact performance.

See also
  Issue 1088, 36% loss of performance with AES, Issue 1010, HIGHT cipher troubles with FileSource

## ◆ Resynchronize()

template<class BASE >

void CFB_CipherTemplate< BASE >::Resynchronize | ( | const byte * | iv,
|  | int | length = `-1`
| ) |  |

Resynchronize the cipher.

Parameters

  iv | a byte array used to resynchronize the cipher
  length | the size of the IV array

## ◆ OptimalBlockSize()

template<class BASE >

unsigned int CFB_CipherTemplate< BASE >::OptimalBlockSize | ( |  | ) | const
| inline

Provides number of ideal bytes to process.

Returns
  the ideal number of bytes to process

Internally, the default implementation returns GetBytesPerIteration()

See also
  GetBytesPerIteration() and GetOptimalNextBlockSize()

Definition at line 603 of file strciphr.h.

## ◆ GetOptimalNextBlockSize()

template<class BASE >

unsigned int CFB_CipherTemplate< BASE >::GetOptimalNextBlockSize | ( |  | ) | const
| inline

Provides number of ideal bytes to process.

Returns
  the ideal number of bytes to process

Internally, the default implementation returns remaining unprocessed bytes

See also
  GetBytesPerIteration() and OptimalBlockSize()

Definition at line 609 of file strciphr.h.

## ◆ OptimalDataAlignment()

template<class BASE >

unsigned int CFB_CipherTemplate< BASE >::OptimalDataAlignment | ( |  | ) | const
| inline

Provides number of ideal data alignment.

Returns
  the ideal data alignment, in bytes

See also
  GetAlignment() and OptimalBlockSize()

Definition at line 614 of file strciphr.h.

## ◆ IsRandomAccess()

template<class BASE >

bool CFB_CipherTemplate< BASE >::IsRandomAccess | ( |  | ) | const
| inline

Flag indicating random access.

Returns
  true if the cipher is seekable, false otherwise

See also
  Seek()

Definition at line 619 of file strciphr.h.

## ◆ IsSelfInverting()

template<class BASE >

bool CFB_CipherTemplate< BASE >::IsSelfInverting | ( |  | ) | const
| inline

Determines if the cipher is self inverting.

Returns
  true if the stream cipher is self inverting, false otherwise

Definition at line 623 of file strciphr.h.

## ◆ AlgorithmProvider()

template<class BASE >

std::string CFB_CipherTemplate< BASE >::AlgorithmProvider | ( |  | ) | const
| inline

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Generally speaking Wei Dai's original IA-32 ASM code falls under "SSE2". Labels like "SSSE3" and "SSE4.1" follow after Wei's code and use intrinsics instead of ASM.

Algorithms which combine different instructions or ISAs provide the dominant one. For example on x86 `AES/GCM` returns "AESNI" rather than "CLMUL" or "AES+SSE4.1" or "AES+CLMUL" or "AES+SSE4.1+CLMUL".

Note
  Provider is not universally implemented yet.

Definition at line 639 of file strciphr.h.

The documentation for this class was generated from the following file:

- strciphr.h